jQuery(function($){

  var loaderIcon = $('.measureConverter .loader');
  var timer = null;

  $('.selectMeasure').change(function(){

    loaderIcon.show();
    
    var type = $(this).val();

    var ajaxData = {
      'action': 'getMeasurementUnits',
      'type': type
    };

    $.getJSON('wp-admin/admin-ajax.php', ajaxData, function(response){

      var options = '';
      $.each(response, function(i, el){
        options += '<option value="'+ el +'">'+ el +'</option>'
      });
      $('.selectUnits').html(options);
      loaderIcon.hide();
      // Convert current
      $('.convertedValue').trigger('keyup');
    });

  }).change();

  $('.selectUnits').change(function(){
    $('.convertedValue').trigger('keyup');
  });

  $('.convertedValue').keyup(function(){

    var $this = $(this);

    if($this.val() == '')
      return;

    clearTimeout(timer);

    timer = setTimeout(function(){

      loaderIcon.show();

      var container = $this.closest('.measureConverter');
      var fromUnits = container.find('.selectUnits.from').val();
      var toUnits =  container.find('.selectUnits.to').val();
      var type =  container.find('.selectMeasure').val();
      var value =  container.find('.convertedValue').val();

      var ajaxData = {
        'action': 'measurementConversion',
        'type': type,
        'fromUnits': fromUnits,
        'toUnits': toUnits,
        'value' : value
      };

      $.post('wp-admin/admin-ajax.php', ajaxData, function(resp){
        container.find('.convertedResult').val(resp);
        loaderIcon.hide();
      });

    }, 200);

  });




  // Admin area:

  var $optionsDiv = $('.measureConverterOptions');

  $optionsDiv.find('.root').live('change',function(){

    var $this = $(this);

    if($this.is(':checked')){
      $this.closest('li').find('ul').slideDown(200);
    } else {
      $this.closest('li').find('ul').slideUp(200);
    }

  });

  $optionsDiv.find('.addCustomUnit>a').live('click', function(e){

    var $this = $(this);
    $this.siblings('p').show();

    var measureName = $this.closest('.measureNode').data('measure-name');
    var index = $this.closest('.measureNode').find('.addCustomUnit').length - 1;

    var insert = '<label>Name: <input type="text" name="addNew['+ measureName +']['+ index +'][unitName]"></label></br>' +
                 '<label>Value: <input type="text" name="addNew['+ measureName +']['+ index +'][unitVal]"></label>';

    $this.parent().after($this.parent().clone());
    $this.parent().html(insert);
    
    e.preventDefault();
  });

  $optionsDiv.find('.addCustomGroup>a').live('click', function(e){

    var $this = $(this);
    $this.siblings('p').show();

    var insert = '<label><span class="eqwidth">Group Name:</span><input class="groupName" type="text"></label></br>' +
                 '<label><span class="eqwidth">Main unit: </span><input class="unitName" type="text"></label>' +
                 '<input class="unitVal" type="hidden" value="1">';

    $this.parent().after($this.parent().clone());
    $this.parent().html(insert);

    e.preventDefault();
  });

  $optionsDiv.find('.addCustomGroup .groupName').live('blur', function(){
     $(this).closest('.addCustomGroup').find('.unitName').trigger('blur');
   });

  $optionsDiv.find('.addCustomGroup .unitName').live('blur', function(){
    var $this = $(this);
    var $li =  $this.closest('.addCustomGroup');

    var measureName = $li.find('.groupName').val();
    $this.attr('name', 'addNew['+ measureName +'][0][unitName]');
    $li.find('.unitVal').attr('name', 'addNew['+ measureName +'][0][unitVal]')

  });

  $optionsDiv.find('.deleteUnit').live('click', function(e){

    var $this = $(this);

    var unitInfo = $this.data('unit');

    var ajaxData = {
      'action': 'deleteMeasurementUnit',
      'unitName': unitInfo.name,
      'unitGroup' : unitInfo.group
    };

    $.post('admin-ajax.php', ajaxData, function(resp){
      $this.closest('li').remove();
    });

    e.preventDefault();
  });

  $optionsDiv.find('.deleteGroup').live('click', function(e){

    var $this = $(this);

    var confirmed = confirm("Are you sure you want to delete group? All items in the group will be deleted.")

    if(confirmed){
      var ajaxData = {
        'action': 'deleteMeasurementUnitGroup',
        'unitGroup' : $this.data('unit-group')
      };

      $.post('admin-ajax.php', ajaxData, function(resp){
        $this.closest('.measureNode').remove();
      });
    }

    e.preventDefault();
  });


});